package com.jasamedika.medifirst2000.controller;

import com.jasamedika.medifirst2000.constants.MessageResource;
import com.jasamedika.medifirst2000.controller.base.LocaleController;
import com.jasamedika.medifirst2000.exception.ServiceVOException;
import com.jasamedika.medifirst2000.service.DiagnosaKeperawatanService;
import com.jasamedika.medifirst2000.service.DiagnosaKeperawatanTransaksiService;
import com.jasamedika.medifirst2000.vo.DiagnosaKeperawatanTransaksiVO;
import com.jasamedika.medifirst2000.vo.DiagnosaKeperawatanVO;
import org.slf4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.ResponseEntity;
import org.springframework.orm.jpa.JpaSystemException;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletRequest;
import javax.validation.Valid;
import java.util.List;
import java.util.Map;

import static com.jasamedika.medifirst2000.constants.Constants.MessageInfo.ERROR_MESSAGE;
import static com.jasamedika.medifirst2000.core.web.WebConstants.HttpHeaderInfo.LABEL_SUCCESS;
import static com.jasamedika.medifirst2000.util.rest.RestUtil.getJsonHttpStatus;
import static com.jasamedika.medifirst2000.util.rest.RestUtil.getJsonResponse;
import static org.slf4j.LoggerFactory.getLogger;
import static org.springframework.http.HttpStatus.*;
import static org.springframework.http.MediaType.APPLICATION_JSON_VALUE;
import static org.springframework.web.bind.annotation.RequestMethod.POST;

@RestController
@RequestMapping("/diagnosa-keperawatan")
public class DiagnosaKeperawatanTransaksiController extends LocaleController<DiagnosaKeperawatanVO> {

	private static final Logger LOGGER = getLogger(DiagnosaKeperawatanTransaksiController.class);

	@Autowired
	private DiagnosaKeperawatanTransaksiService service;

	@Autowired
	private DiagnosaKeperawatanService diagnosaKeperawatanService;

	@RequestMapping(value = "/save-diagnosa-keperawatan", method = POST, produces = APPLICATION_JSON_VALUE, consumes = APPLICATION_JSON_VALUE)
	public ResponseEntity<Map<String, Object>> saveDiagnosaKeperawatanTransaksi(
			@Valid @RequestBody List<DiagnosaKeperawatanTransaksiVO> vo, HttpServletRequest request) {
		try {
			Map<String, Object> result = service.saveDiagnosaKeperawatan(vo);
			if (null != result)
				mapHeaderMessage.put(LABEL_SUCCESS, getMessage(MessageResource.LABEL_SUCCESS, request));
			return getJsonResponse(result, CREATED, mapHeaderMessage);
		} catch (ServiceVOException e) {
			LOGGER.error("Got ServiceVOException {} when saveDiagnosaKeperawatan", e.getMessage());
			addHeaderMessage(ERROR_MESSAGE, e.getMessage());
			return getJsonHttpStatus(INTERNAL_SERVER_ERROR, mapHeaderMessage);
		} catch (JpaSystemException jse) {
			LOGGER.error("Got JpaSystemException {} when saveDiagnosaKeperawatan", jse.getMessage());
			addHeaderMessage(ERROR_MESSAGE, jse.getMessage());
			return getJsonHttpStatus(CONFLICT, mapHeaderMessage);
		}
	}

	@RequestMapping(value = "/get-all-master")
	@ResponseBody
	public List<Map<String, Object>> getDiagnosaKeperawatan() {
		return diagnosaKeperawatanService.getDiagnosaKeperawatan();
	}

	@RequestMapping(value = "/get-detail-by-master")
	@ResponseBody
	public List<Map<String, Object>> getDetailDiagnosaKeperawatan(
			@RequestParam(value = "id", required = false) Integer id) {
		return diagnosaKeperawatanService.getDetailDiagnosisKeperawatan(id);
	}

	@RequestMapping(value = "/get-detail-by-transaction")
	@ResponseBody
	public Map<String, Object> getDetailDiagnosaKeperawatanTransaction(
			@RequestParam(value = "noRec", required = false) String noRec) {
		return diagnosaKeperawatanService.getDetailDiagnosaKeperawatanTransaction(noRec);
	}

}
